Index: forum_banishment_vote.php
===================================================================
--- forum_banishment_vote.php	(Revision 24007)
+++ forum_banishment_vote.php	(Arbeitskopie)
@@ -32,59 +32,55 @@
 }
 if (!$logged_in_user->prefs->privilege(S_MODERATOR)) {
     // Can't moderate without being moderator
-    error_page("You are not authorized to banish users.");
+    error_page(tra("You are not authorized to banish users."));
 }    
 
 $userid = get_int('userid');
 $user = BoincUser::lookup_id($userid);
 
-page_head('Banishment Vote');
+page_head(tra("Banishment Vote"));
 
 echo "<form action=\"forum_banishment_vote_action.php?userid=".$userid."\" method=\"POST\">\n";
 echo form_tokens($logged_in_user->authenticator);
 start_table();
-row1("Banishment Vote");
+row1(tra("Banishment Vote"));
 
 if (get_str('action')=="start") {
     if (!$user) {
-        error_page("no user");
+        error_page(tra("No user with this ID found."));
     }
     $x = $user->banished_until;
     if ($x>time()) {
-        error_page("User is already banished");
+        error_page(tra("User is already banished"));
     }
     //display input that selects reason
     echo "<input type=hidden name=action value=start>";
     echo "<input type=\"hidden\" name=\"userid\" value=\"".$userid."\">\n";
-    row1("Are you sure you want to banish ".$user->name."?
-        This will prevent ".$user->name." from posting for chosen time period.<br />
-        It should be done only if ".$user->name."
-        has consistently exhibited trollish behavior.");
+    row1(tra("Are you sure you want to banish %1?<br/>This will prevent %1 from posting for chosen time period.<br/>It should be done only if %1 has consistently exhibited trollish behavior.", $user->name));
     row2("",
-    "Select the reason category, optionally write a longer description of why the user should be banished.");
-    row2("Category",
+    tra("Select the reason category, optionally write a longer description of why the user should be banished."));
+    row2(tra("Category"),
     "<select name=\"category\">
-    <option value=\"1\">Obscene</option>
-    <option value=\"2\">Flame/Hate mail</option>
-    <option value=\"3\">User Request</option>
-    <option value=\"4\">Other</option>
+    <option value=\"1\">".tra("Obscene")."</option>
+    <option value=\"2\">".tra("Flame/Hate mail")."</option>
+    <option value=\"3\">".tra("User Request")."</option>
+    <option value=\"4\">".tra("Other")."</option>
 </select>");
-row2("Reason<br>Mailed if nonempty",
+row2(tra("Reason")."<br>".tra("Mailed if nonempty"),
     "<textarea name=\"reason\" rows=\"10\" cols=\"80\"></textarea>");
 
 row2(
     "",
-    "<input type=\"submit\" name=\"submit\" value=\"Proceed with vote\">"
+    "<input type=\"submit\" name=\"submit\" value=\"".tra("Proceed with vote")."\">"
 );
 } elseif (get_str('action')=="yes") {
     vote_yes($config,$logged_in_user,$user);
 } elseif (get_str('action')=="no") {
     vote_no($config,$logged_in_user,$user);
 } else {
-    error_page( "Unknown action");
+    error_page("Unknown action");
 }
 
-
 end_table();
 
 echo "</form>";
Index: forum_post.php
===================================================================
--- forum_post.php	(Revision 24007)
+++ forum_post.php	(Arbeitskopie)
@@ -37,10 +37,7 @@
 $forum = BoincForum::lookup_id($forumid);
 
 if (!user_can_create_thread($logged_in_user, $forum)) {
-    error_page(
-        "Only project admins may create a thread here.
-        However, you may reply existing threads."
-    );
+    error_page(tra("Only project admins may create a thread here. However, you may reply existing threads."));
 }
 check_post_access($logged_in_user, $forum);
 
@@ -60,9 +57,7 @@
     }
     check_tokens($logged_in_user->authenticator);
     if (!akismet_check($logged_in_user, $content)) {
-        $warning = "Your message was flagged as spam by the Akismet
-            anti-spam system.  Please modify your text and try again.
-        ";
+        $warning = tra("Your message was flagged as spam by the Akismet anti-spam system. Please modify your text and try again.");
         $preview = tra("Preview");
     } else {
         $thread = create_thread(
@@ -72,7 +67,7 @@
     }
 }
 
-page_head('Create new thread','','','', $bbcode_js);
+page_head(tra("Create new thread"),'','','', $bbcode_js);
 show_forum_header($logged_in_user);
 
 if ($warning) {
@@ -107,7 +102,7 @@
 $body_help = "";
 
 if ($content && !$title) {
-    $submit_help = "<br /><font color=\"red\">Remember to add a title</font>";
+    $submit_help = "<br /><font color=\"red\">".tra("Remember to add a title")."</font>";
 }
 
 if ($force_title && $title){
@@ -129,10 +124,10 @@
 }
 
 if (is_news_forum($forum)) {
-    row2("", "<input name=export type=checkbox> Show this item as a Notice in the BOINC Manager<br><span class=note>Do so only for items likely to be of interest to all volunteers</span>");
+    row2("", "<input name=export type=checkbox>".tra("Show this item as a Notice in the BOINC Manager")."<br><span class=note>".tra("Do so only for items likely to be of interest to all volunteers.")."</span>");
 }
 row2("", "<input name=\"add_signature\" value=\"add_it\" ".$enable_signature." type=\"checkbox\"> ".tra("Add my signature to this post"));
-row2("", "<input type=\"submit\" name=\"preview\" value=\"".tra("Preview")."\"> <input type=\"submit\" value=\"OK\">");
+row2("", "<input type=\"submit\" name=\"preview\" value=\"".tra("Preview")."\"> <input type=\"submit\" value=\"".tra("OK")."\">");
 
 
 end_table();
Index: edit_passwd_action.php
===================================================================
--- edit_passwd_action.php	(Revision 24007)
+++ edit_passwd_action.php	(Arbeitskopie)
@@ -30,7 +30,7 @@
 $passwd2 = post_str("passwd2");
 
 if ($passwd != $passwd2) {
-    error_page("New passwords are different");
+    error_page(tra("New passwords are different"));
 }
 
 $config = get_config();
@@ -38,41 +38,35 @@
 if (!$min_passwd_length) $min_passwd_length = 6;
 
 if (!is_ascii($passwd)) {
-    error_page("Passwords may only include ASCII characters.");
+    error_page(tra("Passwords may only include ASCII characters."));
 }
 
 if (strlen($passwd)<$min_passwd_length) {
-    error_page(
-        "New password is too short:
-        minimum password length is $min_passwd_length characters."
-    );
+    error_page(tra("New password is too short: minimum password length is %1 characters.", $min_passwd_length));
 }
 if ($auth) {
     $user = lookup_user_auth($auth);
     if (!$user) {
-        error_page("Invalid account key");
+        error_page(tra("Invalid account key"));
     }
 } else {
     $user = lookup_user_email_addr($email_addr);
     if (!$user) {
-        error_page("No account with that email address was found");
+        error_page(tra("No account with that email address was found"));
     }
     $passwd_hash = md5($old_passwd.$email_addr);
     if ($user->passwd_hash != $passwd_hash) {
-        error_page("Invalid password");
+        error_page(tra("Invalid password"));
     }
 }
 
-page_head("Change password");
+page_head(tra("Change password"));
 $passwd_hash = md5($passwd.$user->email_addr);
 $result = $user->update("passwd_hash='$passwd_hash'");
 if ($result) {
-    echo "Your password has been changed.";
+    echo tra("Your password has been changed.");
 } else {
-    echo "
-        We can't update your password due to a database problem.
-        Please try again later.
-    ";
+    echo tra("We can't update your password due to a database problem. Please try again later.");
 }
 
 page_tail();
Index: login_action.php
===================================================================
--- login_action.php	(Revision 24007)
+++ login_action.php	(Arbeitskopie)
@@ -29,7 +29,7 @@
 
 // check for email/password case
 //
-$email_addr = strtolower(strip_tags(post_str("email_addr", true)));
+$email_addr = strtolower(sanitize_tags(post_str("email_addr", true)));
 $passwd = post_str("passwd", true);
 
 if ($email_addr && $passwd) {
Index: delete_account.php
===================================================================
--- delete_account.php	(Revision 24007)
+++ delete_account.php	(Arbeitskopie)
@@ -54,32 +54,30 @@
 if ($cmd == "delete") {
     $retval = delete_account($user);
     if (!$retval) {
-        error_page("Couldn't delete account");
+        error_page(tra("Couldn't delete account"));
     } else {
-        page_head("Account deleted");
-        echo "
-            Your account has been deleted.
-        ";
+        page_head(tra("Account deleted"));
+        echo tra("Your account has been deleted.");
         page_tail();
     }
 } else {
-    page_head("Confirm delete account");
+    page_head(tra("Confirm delete account"));
     echo "
         <table><tr><td>
-        Deleting your account will remove all of your
-        personal information from our servers,
-        including your profile and message-board posts.
-        No jobs will be issued to any computers attached
-        to this account.
+        ".tra("Deleting your account will remove all of your
+personal information from our servers,
+including your profile and message-board posts.
+No jobs will be issued to any computers attached
+to this account.")."
         <p>
-        <b>This cannot be undone.
-        Once your account has been deleted, you cannot get it back.
+        <b>".tra("This cannot be undone.
+Once your account has been deleted, you cannot get it back.")."
         <p>
-        Are you sure you want to delete your account?</b>
+        ".tra("Are you sure you want to delete your account?")."</b>
         <p>
     ";
-    show_button("delete_account.php?cmd=delete", "Yes", "Delete this account");
-    show_button("index.php", "No", "Do not delete this account");
+    show_button("delete_account.php?cmd=delete", tra("Yes"), tra("Delete this account"));
+    show_button("index.php", tra("No"), tra("Do not delete this account"));
     echo "</td></tr></table>\n";
 
     page_tail();
Index: delete_profile.php
===================================================================
--- delete_profile.php	(Revision 24007)
+++ delete_profile.php	(Arbeitskopie)
@@ -20,41 +20,39 @@
 require_once("../inc/util.inc");
 require_once("../inc/profile.inc");
 
-check_get_args(array("delete"));
+check_get_args(array("cmd"));
 
 $user = get_logged_in_user();
 
-if (isset($_POST['delete']) && $_POST['delete']) {
+$cmd = get_str("cmd", true);
+
+if ($cmd == "delete") {
     $result = delete_profile($user);
     if (!$result) {
-        error_page("couldn't delete profile - please try again later");
+        error_page(tra("couldn't delete profile - please try again later"));
     }
     delete_user_pictures($user->id);
-    page_head("Delete Confirmation");
+    page_head(tra("Delete Confirmation"));
     $user->update("has_profile=0");
-    echo "Your profile has been deleted<br>";
+    echo tra("Your profile has been deleted.")."<br>";
     page_tail();
     exit();
 }
 
-page_head("Profile delete confirmation");
+page_head(tra("Profile delete confirmation"));
 
-echo "<form action=", $_SERVER['PHP_SELF'], " method=\"POST\">";
-
 echo "
-    <h2>Are you sure?</h2><p>
-    Deleted profiles are gone forever and cannot be recovered --
-    you will have to start from scratch
-    if you want another profile in the future.
+    <h2>".tra("Are you sure?")."</h2><p>
+    ".tra("Deleted profiles are gone forever and cannot be recovered --
+you will have to start from scratch
+if you want another profile in the future.")."
     <p>
-    If you're sure, click 'Delete'
-    to remove your profile from our database.
-
+    ".tra("If you're sure, click 'Delete'
+to remove your profile from our database.")."
     <p>
-    <input type=submit name=delete value=Delete>
-    </form>
 ";
-
+    show_button("delete_profile.php?cmd=delete", tra("Yes"), tra("Delete my profile"));
+    show_button("index.php", tra("No"), tra("Do not delete my profile"));
 page_tail();
 
 ?>
Index: ffmail_action.php
===================================================================
--- ffmail_action.php	(Revision 24007)
+++ ffmail_action.php	(Arbeitskopie)
@@ -19,6 +19,13 @@
 require_once("../project/project.inc");
 require_once("../inc/email.inc");
 
+$array_get_args = array("preview", "uname", "uemail", "comment", "action");
+for ($i=0; $i<5; $i++) {
+    $array_get_args[]= "n$i";
+    $array_get_args[]= "e$i";
+}
+check_get_args($array_get_args);
+
 function replace($toname, $comment, $fromname, $template) {
     $pat = array(
         '/<toname\/>/',
@@ -44,8 +51,8 @@
 
 $action = get_str('action');
 if ($action=='Preview') {
-    page_head('Email preview');
-    echo "Your email will appear as follows:
+    page_head(tra("Email preview"));
+    echo tra("Your email will appear as follows:")."
         <hr>
     ";
     echo replace("[Friend's name]", $comment, $uname, $html);
@@ -54,13 +61,13 @@
 
     echo "
         <hr>
-        <b><a href=ffmail_action.php$args>Send email</a></b>
+        <b><a href=ffmail_action.php$args>".tra("Send email")."</a></b>
         <p>
-        [Use your browser's back button to return to message form]
+        [".tra("Use your browser's back button to return to message form")."]
     ";
     page_tail();
 } else {
-    page_head("Sending emails");
+    page_head(tra("Sending emails"));
     $found = false;
     for ($i=0; $i<5; $i++) {
         $n = get_str("n$i", true);
@@ -81,23 +88,17 @@
             $mail->Host = $PHPMAILER_HOST;
             $mail->Mailer = $PHPMAILER_MAILER;
             if ($mail->Send()) {
-                echo "<br>email sent successfully to $e\n";
+                echo "<br>".tra("email sent successfully to %1", $e)."\n";
             } else {
-                echo "<br>failed to send email to $e: $mail->ErrorInfo\n";
+                echo "<br>".tra("failed to send email to %1: %2", $e, $mail->ErrorInfo)."\n";
             }
         }
     }
     if ($found) {
         echo "
-            <p>
-            Thanks for telling your friends about ".PROJECT.".
-        ";
+            <p>".tra("Thanks for telling your friends about %1", PROJECT);
     } else {
-        echo "
-            You forgot to enter your friends' names and/or email addresses;
-            Please <a href=ffmail_form.php>return to the form</a>
-            and enter them.
-        ";
+        echo tra("You forgot to enter your friends' names and/or email addresses; Please %1return to the form%2 and enter them.", "<a href=ffmail_form.php>", "</a>");
     }
     page_tail();
 }
Index: donations.php
===================================================================
--- donations.php	(Revision 24007)
+++ donations.php	(Arbeitskopie)
@@ -21,7 +21,7 @@
 check_get_args(array());
 
 if (!defined("PAYPAL_ADDRESS")) {
-    error_page("This project is not accepting donations.");
+    error_page(tra("This project is not accepting donations."));
 }
 
 db_init();
@@ -31,15 +31,15 @@
     $user_id = $logged_in_user->id;
 }
 
-page_head(PROJECT." donations");
+page_head(tra("%1 donations", PROJECT));
 
 if (function_exists("donations_intro")) {
     donations_intro();
 } else {
-    echo "<div>This project is accepting donations via
-        <a href=\"http://www.paypal.com/\">PayPal</a>.</div>
+    echo "<div>".tra("This project is accepting donations via
+%1.", "<a href=\"http://www.paypal.com/\">PayPal</a>")."</div>
         <div class=\"smalltext\">
-        To donate, fill in the amount you want to donate using the field below.
+        ".tra("To donate, fill in the amount you want to donate using the field below.
         PayPal is accepting multiple currencies
         (Canadian Dollars, Euros, Pounds Sterling, U.S. Dollars,
          Yen, Australian Dollars, New Zealand Dollars,
@@ -49,7 +49,7 @@
         You can use included currency converter
         to see the donation amount equivalent in different currencies
         (please note that the rates are only estimates
-         and the actual amount may differ).</div>
+         and the actual amount may differ).")."</div>
     ";
 }
 
@@ -313,19 +313,20 @@
 $estimated .= "</select>\n";
 $estimated .= "<input name=\"outV\" value=\"0.00\" style=\"text-align: right; width: 80px;\" disabled=\"disabled\">\n";
 
-echo row2("Amount you would like to donate", $amount);
-echo row2("Estimated value in", $estimated);
+echo row2(tra("Amount you would like to donate"), $amount);
+echo row2(tra("Estimated value in"), $estimated);
 if ($user_id) {
-    echo row2("Anonymous donation<br><span class=\"smalltext\">Select this if you dont want your name and account number displayed in
-        donator lists.<br>If not checked, you will be recorded as user ID ".$user_id." (".$logged_in_user->name.")</span>",
-        "<input type=\"checkbox\" name=\"anonymous\" id=\"anonymous\" value=\"1\"><label for=\"anonymous\">Yes</label>");
+    $tmp_user_name = $user_id." (".$logged_in_user->name.")";
+    echo row2(tra("Anonymous donation")."<br><span class=\"smalltext\">".tra("Select this if you dont want your name and account number displayed in
+donator lists.<br>If not checked, you will be recorded as user ID %1", $tmp_user_name)."</span>",
+        "<input type=\"checkbox\" name=\"anonymous\" id=\"anonymous\" value=\"1\"><label for=\"anonymous\">".tra("Yes")."</label>");
 } else {
-    echo row2("Anonymous donation<br><span class=\"smalltext\">To assign the donation with your user ID, please log in.",
+    echo row2(tra("Anonymous donation")."<br><span class=\"smalltext\">".tra("To assign the donation with your user ID, please log in."),
         "<input type=\"checkbox\" name=\"anonymous\" id=\"anonymous\" value=\"1\" checked=\"checked\" disabled=\"disabled\">
-        <label for=\"anonymous\">Yes</label>");
+        <label for=\"anonymous\">".tra("Yes")."</label>");
 }
-echo row2("", "<input type=\"submit\" value=\"Proceed\">");
-echo row1("Donations are accepted through<br><img src=\"img/paypal_logo.png\" alt=\"PayPal\">");
+echo row2("", "<input type=\"submit\" value=\"".tra("Proceed")."\">");
+echo row1(tra("Donations are accepted through")."<br><img src=\"img/paypal_logo.png\" alt=\"PayPal\">");
 end_table();
 echo "</form>\n";
 
Index: host_delete.php
===================================================================
--- host_delete.php	(Revision 24007)
+++ host_delete.php	(Arbeitskopie)
@@ -28,24 +28,18 @@
 $hostid = get_int("hostid");
 $host = BoincHost::lookup_id($hostid);
 if (!$host || $host->userid != $user->id) {
-    error_page("We have no record of that computer.");
+    error_page(tra("We have no record of that computer."));
 }
 
 $nresults = host_nresults($host);
 if ($nresults == 0) {
     $host->delete();
 } else {
-    error_page(
-        "You can not delete our record of this computer because our
-        database still contains work for it.
-        You must wait a few days until the work for this computer
-        has been deleted from the project database."
-    );
+    error_page(tra("You can not delete our record of this computer because our database still contains work for it. You must wait a few days until the work for this computer has been deleted from the project database."));
 }
-page_head("Delete record of computer");
-echo "
-    Record deleted.
-    <p><a href=hosts_user.php>Return to list of your computers</a>
+page_head(tra("Delete record of computer"));
+echo tra("Record deleted.")."
+    <p><a href=hosts_user.php>".tra("Return to list of your computers")."</a>
 ";
 page_tail();
 
Index: forum_moderate_thread.php
===================================================================
--- forum_moderate_thread.php	(Revision 24007)
+++ forum_moderate_thread.php	(Arbeitskopie)
@@ -24,16 +24,16 @@
 BoincForumPrefs::lookup($logged_in_user);
 
 if (!get_str('action')) {
-    error_page("no action");
+    error_page("unknown action");
 }
 $thread = BoincThread::lookup_id(get_int('thread'));
 $forum = BoincForum::lookup_id($thread->forum);
         
 if (!is_moderator($logged_in_user, $forum)) {
-    error_page("not authorized");
+    error_page(tra("not authorized"));
 }
 
-page_head("Moderate thread '$thread->title'");
+page_head(tra("Moderate thread '%1'", $thread->title));
 
 echo "<form action=forum_moderate_thread_action.php?thread=$thread->id method=POST>\n";
 echo form_tokens($logged_in_user->authenticator);
@@ -45,14 +45,14 @@
 case 'lock':
     echo "<input type=hidden name=action value=$action>";
     row2("",
-        "Select the reason category, or write a longer description of why you're hiding or locking the thread; then press OK."
+        tra("Select the reason category, or write a longer description of why you're hiding or locking the thread; then press OK.")
     );
-    row2("Category",
+    row2(tra("Category"),
         "<select name=\"category\">
-        <option value=\"1\">Obscene</option>
-        <option value=\"2\">Flame/Hate mail</option>
-        <option value=\"3\">Commercial spam</option>
-        <option value=\"4\">Other</option>
+        <option value=\"1\">".tra("Obscene")."</option>
+        <option value=\"2\">".tra("Flame/Hate mail")."</option>
+        <option value=\"3\">".tra("Commercial spam")."</option>
+        <option value=\"4\">".tra("Other")."</option>
         </select>"
     );
     break;
@@ -69,12 +69,12 @@
     }  
     $selectbox .= '</option>';  
     
-    row2("Current forum", $forum->title);
-    row2("Destination forum", $selectbox);  
+    row2(tra("Current forum"), $forum->title);
+    row2(tra("Destination forum"), $selectbox);  
     break;
 case 'title':
     echo "<input type=hidden name=action value=title>";
-    row2("New title:",
+    row2(tra("New title:"),
         "<input size=80 name=\"newtitle\" value=\"".htmlspecialchars($thread->title)."\">"
     );
     break;
@@ -82,13 +82,13 @@
     error_page("Unknown action");
 }
 
-row2("Reason<br><span class=note>Mailed if nonempty</span>",
+row2(tra("Reason")."<br><span class=note>".tra("Mailed if nonempty")."</span>",
     "<textarea rows=10 cols=80 name=\"reason\"></textarea>"
 );
 
 row2(
     "",
-    "<input type=\"submit\" name=\"submit\" value=\"OK\">"
+    "<input type=\"submit\" name=\"submit\" value=\"".tra("OK")."\">"
 );
 
 end_table();
Index: explain_state.php
===================================================================
--- explain_state.php	(Revision 24007)
+++ explain_state.php	(Arbeitskopie)
@@ -24,113 +24,100 @@
 
 switch($field) {
 case "result_server_state":
-    page_head("Server states");
+    page_head(tra("Server states"));
     echo "
         <p>
-        A tasks's <b>server state</b> indicates
-        whether the task has been sent to a computer,
-        and if so whether the computer has finished it.
-        Possible values are:
+        ".tra("A tasks's <b>server state</b> indicates whether the task has been sent to a computer, and if so whether the computer has finished it. Possible values are:")."
         <p>
     ";
     start_table();
-    row2_plain("<b>Inactive</b>",
-        "The task is not ready to send
-        (for example, because its input files are unavailable)"
+    row2_plain("<b>".tra("Inactive")."</b>",
+        tra("The task is not ready to send (for example, because its input files are unavailable)")
     );
-    row2_plain("<b>Unsent</b>",
-        "The task is ready to send, but hasn't been sent yet."
+    row2_plain("<b>".tra("Unsent")."</b>",
+        tra("The task is ready to send, but hasn't been sent yet.")
     );
-    row2_plain("<b>In Progress</b>",
-        "The task has been sent; waiting for completion."
+    row2_plain("<b>".tra("In Progress")."</b>",
+        tra("The task has been sent; waiting for completion.")
     );
-    row2_plain("<b>Over</b>",
-        "The task has been sent to a computer and either
-        it has timed out or the computer has reported its completion."
+    row2_plain("<b>".tra("Over")."</b>",
+        tra("The task has been sent to a computer and either it has timed out or the computer has reported its completion.")
     );
     break;
 
 case "result_outcome":
-    page_head("Outcomes");
+    page_head(tra("Outcomes"));
     echo "
         <p>
-        A tasks's <b>outcome</b> is defined if its server state is <b>over</b>.
-        Possible values are:
+        ".tra("A tasks's <b>outcome</b> is defined if its server state is <b>over</b>. Possible values are:")."
         <p>
     ";
     start_table();
-    row2_plain("<b>Unknown</b>",
-        "The task was sent to a computer, but the computer has not
-        yet completed the work and reported the outcome."
+    row2_plain("<b>".tra("Unknown")."</b>",
+        tra("The task was sent to a computer, but the computer has not yet completed the work and reported the outcome.")
     );
-    row2_plain("<b>Success</b>",
-        "A computer completed and reported the task successfully."
+    row2_plain("<b>".tra("Success")."</b>",
+        tra("A computer completed and reported the task successfully.")
     );
-    row2_plain("<b>Couldn't send</b>",
-        "The server wasn't able to send the task to a computer
-        (perhaps because its resource requirements were too large)"
+    row2_plain("<b>".tra("Couldn't send")."</b>",
+        tra("The server wasn't able to send the task to a computer (perhaps because its resource requirements were too large)")
     );
-    row2_plain("<b>Client error</b>",
-        "The task was sent to a computer and an error occurred."
+    row2_plain("<b>".tra("Client error")."</b>",
+        tra("The task was sent to a computer and an error occurred.")
     );
-    row2_plain("<b>No reply</b>",
-        "The task was sent to a computer
-        and no reply was received within the time limit."
+    row2_plain("<b>".tra("No reply")."</b>",
+        tra("The task was sent to a computer and no reply was received within the time limit.")
     );
-    row2_plain("<b>Didn't need</b>",
-        "The task wasn't sent to a computer because
-        enough other tasks were completed for this workunit."
+    row2_plain("<b>".tra("Didn't need")."</b>",
+        tra("The task wasn't sent to a computer because enough other tasks were completed for this workunit.")
     );
-    row2_plain("<b>Validate error</b>",
-        "The task was reported but could not be validated,
-        typically because the output files were lost on the server."
+    row2_plain("<b>".tra("Validate error")."</b>",
+        tra("The task was reported but could not be validated, typically because the output files were lost on the server.")
     );
     break;
 
 case "result_client_state":
-    page_head("Client states");
-    echo "<p>A result's <b>client state</b>
-        indicates the stage of processing at which an error occurred.
+    page_head(tra("Client states"));
+    echo "<p>".tra("A result's <b>client state</b> indicates the stage of processing at which an error occurred.")."
         <p>
     ";
     start_table();
-    row2_plain("<b>New</b>",
-        "The computer has not yet completed the task."
+    row2_plain("<b>".tra("New")."</b>",
+        tra("The computer has not yet completed the task.")
     );
-    row2_plain("<b>Done</b>",
-        "The computer completed the task successfully."
+    row2_plain("<b>".tra("Done")."</b>",
+        tra("The computer completed the task successfully.")
     );
-    row2_plain("<b>Downloading</b>",
-        "The computer couldn't download the application or input files."
+    row2_plain("<b>".tra("Downloading")."</b>",
+        tra("The computer couldn't download the application or input files.")
     );
-    row2_plain("<b>Computing</b>",
-        "An error occurred during computation."
+    row2_plain("<b>".tra("Computing")."</b>",
+        tra("An error occurred during computation.")
     );
-    row2_plain("<b>Uploading</b>",
-        "The computer couldn't upload the output files."
+    row2_plain("<b>".tra("Uploading")."</b>",
+        tra("The computer couldn't upload the output files.")
     );
     break;
 
 case "result_time":
-    page_head("Time reported and deadline");
+    page_head(tra("Time reported and deadline"));
     echo "
         <p>
-        A task's <b>Time reported or deadline</b> field depends
-        on whether the task has been reported yet:
+        ".tra("A task's <b>Time reported or deadline</b> field depends on whether the task has been reported yet:")."
         <p>
     ";
     start_table();
-    row2("Already reported", "The date/time it was reported");
-    row2("Not reported yet, deadline in the future",
-        "Deadline, shown in green."
+    row2(tra("Already reported"), tra("The date/time it was reported"));
+    row2(tra("Not reported yet, deadline in the future"),
+        tra("Deadline, shown in green.")
     );
-    row2("Not reported yet, deadline in the past",
-        "Deadline, shown in red."
+    row2(tra("Not reported yet, deadline in the past"),
+        tra("Deadline, shown in red.")
     );
     break;
 
 default:
-    page_head("Unknown field");
+    page_head(tra("Unknown field"));
 }
 
 end_table();
